function isVuexModuleKey(key) {
    return ['namespaced', 'state', 'getters', 'actions', 'mutations', 'modules'].indexOf(key) >= 0;
}
function moduleDecoratorFactory(modOrOpt) {
    return function (constructor) {
        var module = constructor;
        var state = new (module.prototype.constructor)({});
        if (!module.state) {
            module.state = {};
        }
        module.namespaced = modOrOpt && modOrOpt.namespaced;
        Object.keys(state).forEach(function (key) {
            if (state.hasOwnProperty(key) && typeof state[key] !== 'function' && !isVuexModuleKey(key)) {
                module.state[key] = state[key];
            }
        });
    };
}
var VuexModule = /** @class */ (function () {
    function VuexModule(module) {
        this.actions = module.actions;
        this.mutations = module.mutations;
        this.state = module.state;
        this.getters = module.getters;
        this.namespaced = module.namespaced;
        this.modules = module.modules;
    }
    return VuexModule;
}());
export { VuexModule };
export function Module(modOrOpt) {
    if (typeof modOrOpt === 'function') {
        return moduleDecoratorFactory({})(modOrOpt);
    }
    else {
        return moduleDecoratorFactory(modOrOpt);
    }
}
